import React, {Component} from 'react';
import { BrowserRouter as Router, Route, Switch } from "react-router-dom";
import Main from "./components/main";
import "antd/dist/antd.css";
import PrivateRoute from"./components/privateroute/PrivateRoute";
import Login from "./components/Login";
class App extends Component {
    render() {
        return (
            <Router>

<Switch>
                    <PrivateRoute exact  path="/"
                    component={() => <Login />}
                />
                    <PrivateRoute
                        exact
                        path="/ios-inapps"
                        component={() => <Main screen={"ios"} />}
                    />
                    <PrivateRoute
                        exact
                        path="/android-inapps"
                        component={() => <Main screen={"android"}  />}
                    />
                    <PrivateRoute
                        exact
                        path="/studio"
                        component={() => <Main screen={"studio"}   />}
                    />
					<PrivateRoute
							exact
							path="/Failed-InApps"
						component={() => <Main screen={"failed"}  />}
					/>
                    <PrivateRoute
                        exact
                        path="/Game-list"
                        component={() => <Main screen={"detail"}   />}
                    />
                </Switch>
            </Router>
        );
    }
}

export default App;
