import React, {Component,Fragment} from 'react';
import moment from "moment";
import axios from "axios";
import { Select } from 'antd';
import { MDBDataTable } from 'mdbreact';
import FailedAppChart from "./failedappchart";
import Datepicker from "./datepicker";
import {Link} from "react-router-dom";
const { Option } = Select;
class Appfailed extends Component {
    state= {
        data: [],
        Copydata: [],
        filteredData: [],
        loading: true,
        tableRows: [],
        newtable:[],
        gameFil:[],
        appFil:[],
        versionFil:[],
        subsFil:[],
        deviceFil:[],
        startDate:"",
        endDate:""
    };

    onChange =  async (startDate, endDate) => {
        this.setState({startDate:startDate,endDate:endDate});
        let start = moment(startDate).tz('Europe/London').format('MMM Do YYYY');
        let end = moment(endDate).tz('Europe/London').format('MMM Do YYYY');
        console.log("start",start,"end",end);
        if(start === '' && end === ''){
            this.componentDidMount();
        }
        else if(start === end){
            const result = await this.state.Copydata.filter(function(data){
                    var date =  (new Date(parseFloat(data.purchaseDate)));
                    var g = moment(date).tz('Europe/London').format('MMM Do YYYY');

                    return g == start;
                }
            );

            await this.setState({data: result});
            this.setState({tableRows: this.UniqueSum()});

        }
        else{
            var startit=(new Date(startDate).getTime()/1000);
            var endit=(new Date(endDate).getTime()/1000);
			
			startit=startit-50400;
			endit=endit+32400;
			console.log(startit);
			console.log(endit);
			
			console.log(this.state.Copydata);
			const result =  await this.state.Copydata.filter(a =>
                (parseInt(a.purchaseDate) / 1000) >= startit && (parseInt(a.purchaseDate) / 1000) <= endit
				);

            
				console.log(result);
            await  this.setState({data: result});

            await this.setState({tableRows: this.UniqueSum()});

        }
    };

    handleChange = async(value)=> {
        if (value.length !== 0) {
            const filtered = await this.state.data.filter(function (data) {
                return data.appId == value;
            });
            await this.setState({data: filtered});
            this.setState({tableRows: this.UniqueSum()});
            this.setState({gameFil: filtered})
        }
        else{
            this.setState({gameFil: []})
        }
    }

    handleChangeversion = async(value)=> {
        console.log("value onchng",value)
        if (value.length !== 0){
            const filtered1 = await this.state.data.filter(function(data) {
                return data.version == value;
            });
            await  this.setState({data: filtered1});
            this.setState({tableRows: this.UniqueSum()});
            this.setState({versionFil:filtered1})
        }
        else{
            this.setState({versionFil:[]})
        }
    }
    handleChangeitem = async (value) => {
        if (value.length !== 0) {
            const filtered2 = await this.state.data.filter(function (data) {
                return data.appItem == value;
            });
            await this.setState({data: filtered2});
            this.setState({tableRows: this.UniqueSum()});
            this.setState({appFil: filtered2});
        }
        else{
            this.setState({appFil: []});
        }
    }

    handleChangeSubs = async (value) => {
        if (value.length !== 0) {
            const filtered3 = await this.state.data.filter(function (data) {
                return data.isSubscription == value;
            });
            await this.setState({data: filtered3});
            this.setState({tableRows: this.UniqueSum()});
            this.setState({ subsFil: filtered3});
        }
        else{
            this.setState({ subsFil: []});
        }
    }
    handleChangeDevice= async (value) => {
        if (value.length !== 0) {
            const filtered3 = await this.state.data.filter(function (data) {
                return data.device == value;
            });
            await this.setState({data: filtered3});
            this.setState({tableRows: this.UniqueSum()});
            this.setState({ deviceFil: filtered3});
        }
        else{
            this.setState({ deviceFil: []});
        }
    }
    componentDidMount() {
        axios.get(`https://o2vejod3dl.execute-api.us-east-1.amazonaws.com/default/getALLInAPPFailed`)
            .then(res => {
                var data = res.data;
                console.log("res data");
                function compare( a, b ) {
                    if ( a.purchaseDate < b.purchaseDate ){
                        return -1;
                    }
                    if ( a.purchaseDate > b.purchaseDate ){
                        return 1;
                    }
                    return 0;
                }
                data.sort( compare );
                console.log(data);
                var index = 1;
                var units = 1;
                var distinctDataByDate=[];
                data.forEach(element => {
                    
                   var date = new Date (parseFloat(element.purchaseDate));
                    var price = element.price; //for testing purpose.
                    var graphdate = moment(date).tz('Europe/London').format('MMM Do YYYY');
                    element.datetimeForGraph = graphdate;
                    var version = (Math.random() * (0.20 - 0.21) + 0.20).toFixed(2);
                    element.units = units;
                    if(!element.isSubscription){
                        element.isSubscription=0;
                    }
                    index++;
                    var flagg=0;
                    for (var ii = 0; ii <= distinctDataByDate.length -1; ii++){

                        if(distinctDataByDate[ii]['appItem']==element.appItem && distinctDataByDate[ii]['datetimeForGraph']==element.datetimeForGraph){
                            flagg=1;

                            distinctDataByDate[ii].price=parseFloat(distinctDataByDate[ii].price)+parseFloat(element.price);
                            distinctDataByDate[ii].units=distinctDataByDate[ii].units+1;
                            distinctDataByDate[ii].price= distinctDataByDate[ii].price.toFixed(2);
                            //distinctDataByDate[ii].price=distinctDataByDate[ii].price+1;

                        }else{

                        }
                    }
                    if(flagg==0){
                        flagg=1;
                        distinctDataByDate.push(element);
                    }

                });
               // data=distinctDataByDate;
                console.log(data);
                console.log(data);
                this.setState({ data });
                this.setState({ Copydata: data });

                console.log("datastate", this.state.data);
                let now = new Date();
                let start = moment(new Date(now.getFullYear(), now.getMonth(), now.getDate())).tz('Europe/London').add(1, "days");
                let end = moment(start).tz('Europe/London').add(1, "days").subtract(15, "days");
                this.onChange(end,start);
            }).then(res => {

            this.setState({ tableRows: this.UniqueSum()});
            console.log("tablerei",this.state.tableRows);


        })
    }
    UniqueSum() {
        var sum = {}, result;
        var index = 0;
  
        console.log("datat",this.state.data);

        let posts =this.state.data.map((post) => {

            return (
                {
                    PurchaseDate: post.datetimeForGraph,
                    AppItem:post.appItem,
                    AppId: post.appId,
                    TransactionId: post.transactionId ,
                    Version:post.version,
                    ServerResponse:JSON.stringify(post.serverResponse),
                    Device: post.device,
                    StudioId:post.studioID,
                    Units:post.units,
                    Date:post.datetimeForGraph,
                    price:(isNaN(post.price) ? 0 : parseFloat(post.price)),
                    Subscription:post.isSubscription,
					saveFailureWhy:post.saveFailureWhy
                }
            )
        });

        return posts;
    }


    deselectGame=async(value)=>{
        let versionfil = this.state.versionFil;
        let appfil = this.state.appFil;
        let subsfil = this.state.subsFil;
        let devicefil = this.state.deviceFil;
        if(versionfil.length !== 0) {
            await this.setState({data: versionfil});
            this.setState({tableRows: this.UniqueSum()})
        }
        else if(appfil.length !== 0){

            await this.setState({data: appfil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(subsfil.length !== 0){

            await this.setState({data: subsfil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(devicefil.length !== 0){

            await this.setState({data: devicefil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else{
            this.setState({gameFil:[]});
            this.onChange(this.state.startDate,this.state.endDate);
        }
    }
    deselectApp = async(value)=>{
        let versionfil = this.state.versionFil;
        let gamefil = this.state.gameFil;
        let subsfil = this.state.subsFil;
        let devicefil = this.state.deviceFil;
        if(versionfil.length !== 0) {
            await this.setState({data: versionfil});
            this.setState({tableRows: this.UniqueSum()})
        }
        else if(gamefil.length !== 0){

            await this.setState({data: gamefil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(subsfil.length !== 0){

            await this.setState({data: subsfil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(devicefil.length !== 0){

            await this.setState({data: devicefil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else{
            this.setState({appFil:[]});
            this.onChange(this.state.startDate,this.state.endDate);
        }
    }
    deselectVersion=async(value)=>{
        let appfil = this.state.appFil;
        let gamefil = this.state.gameFil;
        let subsfil = this.state.subsFil;
        let devicefil = this.state.deviceFil;
        if(appfil.length !== 0) {
            await this.setState({data: appfil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(gamefil.length !== 0){

            await this.setState({data: gamefil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(subsfil.length !== 0){

            await this.setState({data: subsfil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(devicefil.length !== 0){

            await this.setState({data: devicefil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else{
            this.setState({versionFil:[]});
            this.onChange(this.state.startDate,this.state.endDate);
        }
    }
    deselectSubs=async(value)=>{
        let appfil = this.state.appFil;
        let gamefil = this.state.gameFil;
        let versionfil = this.state.versionFil;
        let devicefil = this.state.deviceFil;
        if(versionfil.length !== 0){
            await this.setState({data: versionfil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else  if(appfil.length !== 0) {
            await this.setState({data: appfil});
            this.setState({tableRows: this.UniqueSum()})

        }

        else if(gamefil.length !== 0){
            await this.setState({data: gamefil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(devicefil.length !== 0){

            await this.setState({data: devicefil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else{
            this.setState({subsFil:[]});
            this.onChange(this.state.startDate,this.state.endDate);
        }
    }
    deselectDevice=async(value)=>{
        let appfil = this.state.appFil;
        let gamefil = this.state.gameFil;
        let versionfil = this.state.versionFil;
        let subsFil = this.state.subsFil;
        if(versionfil.length !== 0){
            await this.setState({data: versionfil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else  if(appfil.length !== 0) {
            await this.setState({data: appfil});
            this.setState({tableRows: this.UniqueSum()})

        }

        else if(gamefil.length !== 0){
            await this.setState({data: gamefil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(subsFil.length !== 0){

            await this.setState({data: subsFil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else{
            this.setState({deviceFil:[]});
            this.onChange(this.state.startDate,this.state.endDate);
        }
    }

    render() {
        function getUnique(arr, comp) {

            const unique = arr
                .map(e => e[comp])

                // store the keys of the unique objects
                .map((e, i, final) => final.indexOf(e) === i && i)

                // eliminate the dead keys & store unique objects
                .filter(e => arr[e]).map(e => arr[e]);

            return unique;
        }

        const uniqueAppId = getUnique(this.state.data,'appId');
        const uniqueVersion = getUnique(this.state.data,'version');
        const uniqueappitems = getUnique(this.state.data,'appItem');
        const uniquesubs = getUnique(this.state.data,'isSubscription');
        const uniqueDev = getUnique(this.state.data,'device');
        const options =uniqueAppId.map((option) => {

            return (
                <Option key={option.id} value={option.appId} label={option.appId}>
                    <div className="demo-option-label-item">
                        {option.appId}
                    </div>
                </Option>

            )
        });
        const deviceOptions =uniqueDev.map((option) => {

            return (
                <Option key={option.id} value={option.device} label={option.device}>
                    <div className="demo-option-label-item">
                        {option.device}
                    </div>
                </Option>

            )
        });
        const subsOptions =uniquesubs.map((option) => {

            return (
                <Option key={option.id} value={option.isSubscription} label={option.isSubscription === 0 ?"Regular":"Subscription"}>
                    <div className="demo-option-label-item">
                        {option.isSubscription === 0 ?"Regular":"Subscription"}
                    </div>
                </Option>

            )
        });
        const versions = uniqueVersion.map((version) => {

            return (
                <Option key={version.id} value={version.version} label={version.version}>
                    <div className="demo-option-label-item">
                        {version.version}
                    </div>
                </Option>


            )
        });
        const appitems = uniqueappitems.map((item) => {

            return (
                <Option key={item.id} value={item.appItem} label={item.appItem}>
                    <div className="demo-option-label-item">
                        {item.appItem}
                    </div>
                </Option>


            )
        });

        const    data = {

            columns: [
                {
                    label: 'PurchaseDate',
                    field: 'PurchaseDate',
					sort: 'disabled',
                    width: 150
                },
				{
                    label: 'Device',
                    field: 'Device',
                    sort: 'asc',
                    width: 100
                },
				{
                    label: 'Failure Case',
                    field: 'saveFailureWhy',
                    sort: 'asc',
                    width: 100
                },
                {
                    label: 'AppId',
                    field: 'AppId',
                    sort: 'asc',
                    width: 150
                },
                {
                    label: 'AppItem',
                    field: 'AppItem',
                    sort: 'asc',
                    width: 270
                },
                {
                    label: 'Version',
                    field: 'Version',
                    sort: 'asc',
                    width: 270
                },
                {
                    label: 'TransactionId',
                    field: 'TransactionId',
                    sort: 'asc',
                    width: 200,
                    defaultSortField:true
                },
                


                {
                    label: 'StudioId',
                    field: 'StudioId',
                    sort: 'asc',
                    width: 100
                },
                {
                    label: 'Subscription',
                    field: 'Subscription',
                    sort: 'asc',
                    width: 100
                },
                {
                    label: 'ServerResponse',
                    field: 'ServerResponse',
                    sort: 'asc',
                    width: 100
                }

            ],
              rows:[...this.state.tableRows].reverse(),

        }



        return (

            <Fragment>

                <div className="container graph-wrap">
                    <h1>
                        FAILED INAPPS</h1><br/>
                    <div className="daterange">
                        <Datepicker onChange={this.onChange} />
                        <Select
                            mode="multiple"
                            onDeselect={this.deselectSubs}
                            style={{ width: '100%' }}
                            placeholder="Games Type"
                            onChange={this.handleChangeSubs}
                            optionLabelProp="label"
                            showArrow={true}
                        >
                            {subsOptions}

                        </Select>
                        <Select
                            mode="multiple"
                            onDeselect={this.deselectDevice}
                            style={{ width: '100%' }}
                            placeholder="Device"
                            onChange={this.handleChangeDevice}
                            optionLabelProp="label"
                            showArrow={true}
                        >
                            {deviceOptions}

                        </Select>
                    </div>
                    <Select
                        mode="multiple"
                        onDeselect={this.deselectGame}
                        style={{ width: '100%' }}
                        placeholder="Game name/id"
                        onChange={this.handleChange}
                        optionLabelProp="label"
                        showArrow={true}

                    >
                        {options}

                    </Select>
                    <Select
                        mode="multiple"
                        onDeselect={this.deselectApp}
                        style={{ width: '100%' }}
                        placeholder="InApp Product"
                        onChange={this.handleChangeitem}
                        optionLabelProp="label"
                        showArrow={true}
                    >
                        {appitems}

                    </Select>
                    <Select
                        mode="multiple"
                        onDeselect={this.deselectVersion}
                        style={{ width: '100%' }}
                        placeholder="Game version"
                        onChange={this.handleChangeversion}
                        optionLabelProp="label"
                        showArrow={true}
                    >
                        {versions}

                    </Select>


                    <div className="chart">

                        <FailedAppChart data={this.state.tableRows}/>


                    </div>
                    <div className="table-fix">
                        <MDBDataTable

                            striped
                            bordered
                            small
                            data={data}
                        />
                    </div>
                </div>



            </Fragment>

        );
    }
}
export default Appfailed;