import React, {Component,Fragment} from 'react';

// import { DatePicker  } from "antd";
import Chart from "./chart";
import moment from "moment-timezone";
import axios from "axios";
import { Select } from 'antd';
import { MDBDataTable } from 'mdbreact';
import Datepicker from "./datepicker";
// const { RangePicker } = DatePicker;


//MDBDataTable.moment( 'mm HH: MMM D, YY' );

moment.tz.link('Europe/London');

const { Option } = Select;
class Content extends Component {
    state= {
        data: [],
        Copydata: [],
        filteredData: [],
        loading: true,
        tableRows: [],
		newtable:[],
        gameFil:[],
        appFil:[],
        subsFil:[],
        versionFil:[],
        TypeFil:[],
        startDate:"",
        endDate:"",

    };

    onChange =  async (startDate, endDate) => {
        this.setState({startDate:startDate,endDate:endDate});
        let start = moment(startDate).tz('Europe/London').format('MMM Do YYYY');
		
		console.log("startttt");
		console.log(start);
        let end = moment(endDate).tz('Europe/London').format('MMM Do YYYY');
        console.log("start",start,"end",end);
        if(start === '' && end === ''){
            this.componentDidMount();
        }

        else if(start === end){
            const result = await this.state.Copydata.filter(function(data){
                    var date =  (new Date(parseFloat(data.datetime)));
                var g = moment(date).tz('Europe/London').format('MMM Do YYYY');
				console.log("same date");
				console.log(g);
                    return g == start;
                }
            );
			console.log(result);
            await this.setState({data: result});

            this.setState({tableRows: this.UniqueSum()});

        }
        else{
			console.log("fahad");
			console.log(startDate);
			console.log(endDate);
            var startit=(new Date(startDate).getTime()/1000);
            var endit=(new Date(endDate).getTime()/1000); // if add next day then +86400
			
			console.log("kkkkkkkkkkkkkkee");
			console.log(startit);
			console.log("kkkkkkkkkkkkkk");
			console.log(endit);
			startit=startit-50400;
			endit=endit+32400;
			
			console.log("2kkkkkkkkkkkkkkee");
			console.log(startit);
			console.log("2kkkkkkkkkkkkkk");
			console.log(endit);
			
			console.log(startit);
			console.log(endit);
			console.log(this.state.data);
			console.log("end")
            const result =  await this.state.Copydata.filter(a =>
                (parseInt(a.datetime) / 1000) >= startit && (parseInt(a.datetime) / 1000) <= endit
				);
            console.log("fahad2");
			console.log(result);
			await  this.setState({data: result});
			
			

            this.setState({tableRows: this.UniqueSum()});
        }
    };

    handleChange = async(value)=> {
        if (value.length !== 0) {
            const filtered = await this.state.data.filter(function (data) {
                return data.appId == value;
            });
            await this.setState({data: filtered});
            this.setState({tableRows: this.UniqueSum()});
            this.setState({gameFil: filtered})
        }
        else{
            this.setState({gameFil: []})
        }
    }

    handleChangeversion = async(value)=> {
        console.log("value onchng",value)
        if (value.length !== 0){
            const filtered1 = await this.state.data.filter(function(data) {
                return data.version == value;
            });
            await  this.setState({data: filtered1});
            this.setState({tableRows: this.UniqueSum()});
            this.setState({versionFil:filtered1})
        }
        else{
            this.setState({versionFil:[]})
        }
    }
    handleChangeitem = async (value) => {
        if (value.length !== 0) {
            const filtered2 = await this.state.data.filter(function (data) {
                return data.appItem == value;
            });
            await this.setState({data: filtered2});
            this.setState({tableRows: this.UniqueSum()});
            this.setState({appFil: filtered2});
        }
        else{
            this.setState({appFil: []});
        }
    }
    handleChangeSubs = async (value) => {
        if (value.length !== 0) {
            const filtered3 = await this.state.data.filter(function (data) {
                return data.isSubscription == value;
            });
            await this.setState({data: filtered3});
            this.setState({tableRows: this.UniqueSum()});
            this.setState({subsFil: filtered3});
        }
        else{
            this.setState({subsFil: []});
        }
    }
    handleChangeType= async (value) => {
        if (value.length !== 0) {
            const filtered3 = await this.state.data.filter(function (data) {
                return data.type == value;
            });
            await this.setState({data: filtered3});
            this.setState({tableRows: this.UniqueSum()});
            this.setState({ TypeFil: filtered3});
        }
        else{
            this.setState({ TypeFil: []});
        }
    }
    componentDidMount() {
        axios.get(`https://kbbge8tzm8.execute-api.us-east-1.amazonaws.com/inappios/inappios`)
            .then(res => {
                var data = res.data;
                console.log("resdata",data)
function compare( a, b ) {
  if (a.datetime < b.datetime ){
    return -1;
  }
  if (a.datetime > b.datetime){
    return 1;
  }
  return 0;
}

data.sort( compare );
                console.log("res",data);
                var index = 1;
                var units = 1;
				var distinctDataByDate=[];

                data.forEach(element => {
                    var date = new Date (parseFloat(element.datetime));
                    var price = element.price; //for testing purpose.
                    // element.datetime = date;
                    var graphdate = moment(date).tz('Europe/London').format('MMM Do YYYY');
                    //  var graphdate1 = new Date(date);
                    element.datetimeForGraph = graphdate;
                    //  element.datetime =graphdate;
                    var version = (Math.random() * (0.20 - 0.21) + 0.20).toFixed(2);
                    //element.version = version;
                    //element.studioID = "PzC";

                    element.units = units;
                    if(!element.isSubscription){
                        element.isSubscription=0;
                    }
                    if(element.type=== "0"){
                        element.type="Sandbox"
                    }
                    else if(element.type=== "1"){
                        element.type="Live"
                    }
                    else if(element.type === "2"){
                        element.type="In Review"
                    }
                    // element.price = price + index; //for testing purpose.
                    index++;
					
					
					//sort by item and date

                    var flagg=0;
                    for (var ii = 0; ii <= distinctDataByDate.length -1; ii++){
  
                     if(distinctDataByDate[ii]['appItem']==element.appItem && distinctDataByDate[ii]['datetimeForGraph']==element.datetimeForGraph){
                         flagg=1;
                        
                        distinctDataByDate[ii].price=parseFloat(distinctDataByDate[ii].price)+parseFloat(element.price);
                        distinctDataByDate[ii].units=distinctDataByDate[ii].units+1;
						 distinctDataByDate[ii].price= distinctDataByDate[ii].price.toFixed(2);
                        //distinctDataByDate[ii].price=distinctDataByDate[ii].price+1;                        

                     }else{

                     }
                    
                    }
                    if(flagg==0){
                        flagg=1;
                        distinctDataByDate.push(element);
                    }

                });
				//data
				data=distinctDataByDate;

                this.setState({ data });
                this.setState({ Copydata: data });
                console.log("data after settings:", this.state.Copydata);
               
				let now = new Date();
                let start = moment(new Date(now.getFullYear(), now.getMonth(), now.getDate())).tz('Europe/London').add(1, "days");
                let end = moment(start).tz('Europe/London').add(1, "days").subtract(15, "days");
				
				console.log("onchanheeee ");
				
				console.log(start);
				
				var end2 = moment(start).tz('Europe/London').format('MMM Do YYYY');
				console.log(end2);
                //let valstart=moment(start).subtract(30, "days");
				
                this.onChange(end,start);
            }).then(res => {

                this.setState({ tableRows: this.UniqueSum()});
                console.log("tablerei",this.state.tableRows);

        })


    }
    UniqueSum() {

        let posts =this.state.data.map((post) => {
            return (
                {
                    Name: post.appId,
                    Version:post.version,
                    Appitem: post.appItem,
                    Date: post.datetimeForGraph,
                    Datetime:post.datetime,
                    Device: post.device,
                    Subscription:post.isSubscription,
                    Flag: post.flag,
                    Id: post.id,
                    StudioId:post.studioID,
                    Sales:(isNaN(post.price) ? 0 : parseFloat(post.price)),
                    Units:post.units
                }
            )
        });

        return posts;
    }



    deselectGame=async(value)=>{
        let versionfil = this.state.versionFil;
        let appfil = this.state.appFil;
        let subsfil = this.state.subsFil;
        let typefil = this.state.TypeFil;
        if(versionfil.length !== 0) {
            await this.setState({data: versionfil});
            this.setState({tableRows: this.UniqueSum()})
        }
        else if(appfil.length !== 0){

            await this.setState({data: appfil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(subsfil.length !== 0){

            await this.setState({data: subsfil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(typefil.length !== 0){

            await this.setState({data: typefil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else{
            this.setState({gameFil:[]});
            this.onChange(this.state.startDate,this.state.endDate);
        }
    }
    deselectApp = async(value)=>{
        let versionfil = this.state.versionFil;
        let gamefil = this.state.gameFil;
        let subsfil = this.state.subsFil;
        let typefil = this.state.TypeFil;
        if(versionfil.length !== 0) {
            await this.setState({data: versionfil});
            this.setState({tableRows: this.UniqueSum()})
        }
        else if(gamefil.length !== 0){

            await this.setState({data: gamefil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(subsfil.length !== 0){

            await this.setState({data: subsfil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(typefil.length !== 0){

            await this.setState({data: typefil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else{
            this.setState({appFil:[]});
            this.onChange(this.state.startDate,this.state.endDate);
        }
    }
    deselectVersion=async(value)=>{
        let appfil = this.state.appFil;
        let gamefil = this.state.gameFil;
        let subsfil = this.state.subsFil;
        let typefil = this.state.TypeFil;
        if(appfil.length !== 0) {
            await this.setState({data: appfil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(gamefil.length !== 0){

            await this.setState({data: gamefil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(subsfil.length !== 0){

            await this.setState({data: subsfil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(typefil.length !== 0){

            await this.setState({data: typefil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else{
            this.setState({versionFil:[]});
            this.onChange(this.state.startDate,this.state.endDate);
        }
    }
    deselectSubs=async(value)=>{
        let appfil = this.state.appFil;
        let gamefil = this.state.gameFil;
        let versionfil = this.state.versionFil;
        let typefil = this.state.TypeFil;
        if(versionfil.length !== 0){
            await this.setState({data: versionfil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else  if(appfil.length !== 0) {
            await this.setState({data: appfil});
            this.setState({tableRows: this.UniqueSum()})

        }

        else if(gamefil.length !== 0){
            await this.setState({data: gamefil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(typefil.length !== 0){

            await this.setState({data: typefil});
            this.setState({tableRows: this.UniqueSum()})

        }

        else{
            this.setState({subsFil:[]});
            this.onChange(this.state.startDate,this.state.endDate);
        }
    }
    deselectType=async(value)=>{
        let appfil = this.state.appFil;
        let gamefil = this.state.gameFil;
        let versionfil = this.state.versionFil;
        let subsFil = this.state.subsFil;
        if(versionfil.length !== 0){
            await this.setState({data: versionfil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else  if(appfil.length !== 0) {
            await this.setState({data: appfil});
            this.setState({tableRows: this.UniqueSum()})

        }

        else if(gamefil.length !== 0){
            await this.setState({data: gamefil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else if(subsFil.length !== 0){

            await this.setState({data: subsFil});
            this.setState({tableRows: this.UniqueSum()})

        }
        else{
            this.setState({TypeFil:[]});
            this.onChange(this.state.startDate,this.state.endDate);
        }
    }

    render() {
        console.log("i am in render");
        console.log("this.state",this.state.data)
        function getUnique(arr, comp) {
            const unique = arr
                .map(e => e[comp])

                // store the keys of the unique objects
                .map((e, i, final) => final.indexOf(e) === i && i)

                // eliminate the dead keys & store unique objects
                .filter(e => arr[e]).map(e => arr[e]);

            return unique;

        }

        const uniqueAppId = getUnique(this.state.data,'appId');
        const uniqueVersion = getUnique(this.state.data,'version');
        const uniqueappitems = getUnique(this.state.data,'appItem');
        const uniquesubs = getUnique(this.state.data,'isSubscription');
        const uniqueType = getUnique(this.state.data,'type');
        const options =uniqueAppId.map((option) => {

            return (
                <Option key={option.id} value={option.appId} label={option.appId}>
                    <div className="demo-option-label-item">
                        {option.appId}
                    </div>
                </Option>

            )
        });
        const typeOptions =uniqueType.map((option) => {

            return (
                <Option key={option.id} value={option.type} label={option.type}>
                    <div className="demo-option-label-item">
                        {option.type}
                    </div>
                </Option>

            )
        });
        const subsOptions =uniquesubs.map((option) => {

            return (
                <Option key={option.id} value={option.isSubscription} label={option.isSubscription === 0 ?"Regular":"Subscription"}>
                    <div className="demo-option-label-item">
                        {option.isSubscription === 0 ?"Regular":"Subscription"}
                    </div>
                </Option>

            )
        });
        const versions = uniqueVersion.map((version) => {

            return (
                <Option key={version.id} value={version.version} label={version.version}>
                    <div className="demo-option-label-item">
                        {version.version}
                    </div>
                </Option>


            )
        });
        const appitems = uniqueappitems.map((item) => {

            return (
                <Option key={item.id} value={item.appItem} label={item.appItem}>
                    <div className="demo-option-label-item">
                        {item.appItem}
                    </div>
                </Option>


            )
        });

        const    data = {
            columns: [
			
			    {
                    label: 'Date',
                    field: 'Date',
					width: 200,
                    sort: 'disabled'
                    
                }, 
                {
                    label: 'Name',
                    field: 'Name',
                    sort: 'asc',
                    width: 150
                },

                {
                    label: 'Version',
                    field: 'Version',
                    sort: 'asc',
                    width: 150
                },
                {
                    label: 'Appitem',
                    field: 'Appitem',
                    sort: 'asc',
                    width: 270
                },
                {
                    label: 'Device',
                    field: 'Device',
                    sort: 'asc',
                    width: 100
                },


                {
                    label: 'StudioId',
                    field: 'StudioId',
                    sort: 'asc',
                    width: 100
                },
                
                {
                    label: 'Sales',
                    field: 'Sales',
                    sort: 'asc',
                    width: 100
                },
                {
                    label: 'Subscription',
                    field: 'Subscription',
                    sort: 'asc',
                    width: 100
                },				{
                    label: 'Units',
                    field: 'Units',
                    sort: 'asc',
                    width: 100
                },

            ],
            rows:[...this.state.tableRows].reverse(),
        }

        return (

            <Fragment>

                <div className="container graph-wrap">
                        <h1>
                        IOS INAPPS PURCHASES</h1><br/>
						   <div className="daterange">
                             <Datepicker onChange={this.onChange} />
                               <Select
                                   mode="multiple"
                                   onDeselect={this.deselectSubs}
                                   style={{ width: '100%' }}
                                   placeholder="Games Type"
                                   onChange={this.handleChangeSubs}
                                   optionLabelProp="label"
                                   showArrow={true}
                               >

                                   {subsOptions}

                               </Select>
                               <Select
                                   mode="multiple"
                                   onDeselect={this.deselectType}
                                   style={{ width: '100%' }}
                                   placeholder="Type"
                                   onChange={this.handleChangeType}
                                   optionLabelProp="label"
                                   showArrow={true}
                               >
                                   {typeOptions}

                               </Select>
                    </div>
                    <Select
                        mode="multiple"
                         onDeselect={this.deselectGame}
                        style={{ width: '100%' }}
                        placeholder="Game name/id"
                        onChange={this.handleChange}
                        optionLabelProp="label"
                        showArrow={true}
                    >
                        {options}

                    </Select>
                    <Select
                        mode="multiple"
                       onDeselect={this.deselectApp}
                        style={{ width: '100%' }}
                        placeholder="InApp Product"
                        onChange={this.handleChangeitem}
                        optionLabelProp="label"
                        showArrow={true}
                    >
                        {appitems}

                    </Select>
                    <Select
                        mode="multiple"
                      onDeselect={this.deselectVersion}
                        style={{ width: '100%' }}
                        placeholder="Game version"
                        onChange={this.handleChangeversion}
                        optionLabelProp="label"
                        showArrow={true}
                    >
                        {versions}

                    </Select>

                 
              <div className="chart">

                  <Chart data={this.state.tableRows} />


              </div>
                    <div className="table-fix">
                    <MDBDataTable
                        striped
                        bordered
                        small
                        data={data}
                    />
                    </div>
                </div>



            </Fragment>

        );
    }
}
export default Content;