import React, { Component } from 'react'
import { Container, Row, Col } from 'reactstrap'
import ModalForm from './Components/Modals/Modal'
import DataTable from './Components/Tables/DataTable'
import { CSVLink } from "react-csv"
import axios from "axios"

class Detail extends Component {

    state = {
        items: []
    }

    getItems(){
        axios.get(`https://cfufcmpuwc.execute-api.us-east-1.amazonaws.com/InAppIosDetail/inappiosdetail`)
            .then(res => {
                const items = res.data;
				
				
				console.log("pppppppppppp22");
				console.log(items.length);
				//items.forEach(element => {
				for (var ii = 0; ii <= items.length -1; ii++){
					console.log("pppppppppppp");
					console.log(items[ii].flag);
					if(items[ii].flag=="0"){
						items[ii].flag="Sandbox";
					}else if(items[ii].flag=="1"){
						items[ii].flag="Live";
					}else if(items[ii].flag=="2"){
						items[ii].flag="In store";
					}
					
				}		
				//});
                this.setState({ items });
				
				console.log(items);
				console.log("kkkkk");
            })
    }

    addItemToState = (item) => {
        this.setState(prevState => ({
            items: [...prevState.items, item]
        }))
    }

    updateState = (item) => {
        const itemIndex = this.state.items.findIndex(data => data.id === item.id)
        const newArray = [
            // destructure all items from beginning to the indexed item
            ...this.state.items.slice(0, itemIndex),
            // add the updated item to the array
            item,
            // add the rest of the items to the array from the index after the replaced item
            ...this.state.items.slice(itemIndex + 1)
        ]
        this.setState({ items: newArray })
    }

    deleteItemFromState = (id) => {
        const updatedItems = this.state.items.filter(item => item.id !== id)
        this.setState({ items: updatedItems })
    }

    componentDidMount(){
        this.getItems()
    }

    render() {
        return (
            <Container className="App">
                <Row>
                    <Col>
                        <h4 style={{margin: "20px 0"}}>Games List</h4>
                    </Col>
                </Row>
                <Row>
                    <Col>
                        <DataTable items={this.state.items} updateState={this.updateState} deleteItemFromState={this.deleteItemFromState} />
                    </Col>
                </Row>
                <Row>
                    <Col>
                       { this.state.items.length !== 0 ?
                        <CSVLink
                            filename={"db.csv"}
                            color="primary"
                            style={{float: "left", marginRight: "10px"}}
                            className="btn btn-primary"
                            data={this.state.items}>
                            Download CSV
                        </CSVLink > : null }
                        <ModalForm buttonLabel="Add Game" addItemToState={this.addItemToState}/>
                    </Col>
                </Row>
            </Container>
        )
    }
}

export default Detail;