import React from 'react';
import { Button, Form, FormGroup, Label, Input } from 'reactstrap';
import axios from 'axios';
import swal from "sweetalert";
class AddEditForm extends React.Component {
state = {
      id: '',
      Game_Name: '',
      version: '',
      flag: ''

  }

  onChange = e => {
    this.setState({ [e.target.name]: e.target.value })
  }
  yourChangeHandler=(e)=>{
    this.setState({flag: e.target.value })
  }

  submitFormAdd = e => {
    e.preventDefault();
    try {
      const params = {
        id: this.state.id,
        Game_Name: this.state.Game_Name,
        version: this.state.version,
          flag:this.state.flag
      };
      axios.post(`https://cfufcmpuwc.execute-api.us-east-1.amazonaws.com/InAppIosDetail/inappiosdetail/${this.state.id}`, params)
        // .then(response => response.json())
        .then(res => {
          if (res.status == '201') {
            console.log("res", res.status);

            window.location.reload();
          } else {
            console.log('failure')
          }
        })
    }
    catch (err) {
      console.log(err);
    }
  }

  submitFormEdit = e => {
    e.preventDefault();
    try {
      const params = {
        id: this.state.id,
        Game_Name: this.state.Game_Name,
        version: this.state.version,
          flag:this.state.flag
      };
      console.log("reslt",params)
      axios.patch(`https://cfufcmpuwc.execute-api.us-east-1.amazonaws.com/InAppIosDetail/inappiosdetail/${this.state.id}`, params)
        // .then(response => response.json())
        .then(res => {
          console.log("res",res);
          if (res.status == '204') {
           console.log("res",res.status);
              swal("Edited!", "Data edit successfully!", "success");
           window.location.reload();
          } else {
            console.log('failure')
          }
        })
    }
    catch (err) {
      console.log(err);
    }
  }

  componentDidMount=()=>{
    // if item exists, populate the state with proper data
    if (this.props.item) {
      const { id, Game_Name, version,flag } = this.props.item
      this.setState({ id, Game_Name, version,flag });

    }
    else{
      const random = (Math.floor(Math.random() * 10000000000)).toString();

      this.setState({ id:random });
      console.log("id",this.state.id);
    }
      console.log("items here",this.state.flag);
  }

  render() {

    return (
      <Form onSubmit={this.props.item ? this.submitFormEdit : this.submitFormAdd}>
          {this.props.item && (
              <FormGroup>
                  <Label for="first">ID</Label>
                  <Input type="text" name="id" id="first" onChange={this.onChange} value={this.state.id === null ? '' : this.state.id} disabled  />
              </FormGroup>
          )}
          {!this.props.item && (
              <FormGroup>
                  <Label for="first">ID</Label>
                  <Input type="text" name="id" id="first" onChange={this.onChange} value={this.state.id === null ? '' : this.state.id}  disabled  />
              </FormGroup>
          )}


        <FormGroup>
          <Label for="last">Game Name</Label>
          <Input type="text" name="Game_Name" id="last" onChange={this.onChange} value={this.state.Game_Name === null ? '' : this.state.Game_Name} placeholder="Game Name" required />
        </FormGroup>
        <FormGroup>
          <Label for="version">Version</Label>
          <Input type="text"  name="version" id="version" onChange={this.onChange} value={this.state.version === null ? '' : this.state.version} placeholder="ex. 1.0.0" required />
        </FormGroup>
          {this.props.item && (
        <FormGroup>
          <Label for="flag">Flag</Label>
          <select  name="select" className="form-control" id="flag" onChange={this.yourChangeHandler.bind(this)}   required>
            <option>Select flag</option>
              {this.state.flag === "Sandbox" ? <option value="0" selected="selected">Sandbox</option>: <option value="0">Sandbox</option>}
              {this.state.flag === "Live" ?  <option value="1" selected="selected">Live</option>: <option value="1">Live</option>}
              {this.state.flag === "In Review" ?  <option value="2" selected="selected">In Review</option>: <option value="2"> In Review</option>}

          </select>
        </FormGroup>
          )}
          {!this.props.item && (
              <FormGroup>
                  <Label for="flag">Flag</Label>
                  <select  name="select" className="form-control" id="flag" onChange={this.yourChangeHandler.bind(this)}   required>
                      <option>Select flag</option>
                     <option value="0" >Sandbox</option>
                       <option value="1" >Live</option>
                    <option value="2">In Review</option>

                  </select>
              </FormGroup>
          )}
          {this.props.item && (
              <Button>Edit</Button>
          )}
          {!this.props.item && (
              <Button>ADD</Button>
          )}
      </Form>
    );
  }
}

export default AddEditForm