import React , {Component,Fragment}from 'react';
import DateTimeRangeContainer from 'react-advanced-datetimerange-picker';
import {FormControl} from 'react-bootstrap';
import moment from "moment-timezone";

moment.tz.link('Europe/London');
class Datepicker extends Component {

    constructor(props){
        super(props);
        let now = new Date();
		
		console.log("hhhhhhhhhhhhhhh");
		console.log(now.getDate());
        let start = moment(new Date(now.getFullYear(), now.getMonth(), now.getDate())).tz('Europe/London');
		console.log(start);
        let end = moment(start).tz('Europe/London').add(1, "days").subtract(0, "days");
       let valstart=moment(start).tz('Europe/London').subtract(14, "days");
        this.state = {
            start : valstart,
            end : end

        }

        this.applyCallback = this.applyCallback.bind(this);
    }

    applyCallback(startDate, endDate){
        this.setState({
                start: startDate,
                end : endDate
            });
        this.props.onChange(startDate,endDate);
    }
    onChange = () => {
        console.log("dfd")
    }

// componentDidMount() {
//     let now = new Date();
//     let start = moment(new Date(now.getFullYear(), now.getMonth(), now.getDate()));
//     let end = moment(start).subtract(14, "days");
//     this.props.onChange(end,start);
// }

    render(){
        let now = new Date();
        let start = moment(new Date(now.getFullYear(), now.getMonth(), now.getDate())).tz('Europe/London');
        let end = moment(start).add(1, "days").tz('Europe/London').subtract(1,"days");
        let ranges = {

            "Today Only": [moment(start), moment(end)],
            "Yesterday Only": [moment(start).subtract(1, "days"), moment(end).subtract(1, "days")],
            "Last 1 week": [moment(start).subtract(7, "days"), moment(end)],
            "Last 2 week": [moment(start).subtract(14, "days"), moment(end)],
            "Last 30 Days": [moment(start).subtract(30, "days"), moment(end)]
        }
        let local = {
            "format":"DD-MM-YYYY",
            "sundayFirst" : false
        }
        let maxDate = moment(start).tz('Europe/London').add(24, "hour");
		
		console.log("lllllllllllllll");
		console.log(moment(this.state.end).tz('Europe/London').format('MMM Do YYYY'));
		//endit=endit+36000;

        return(
            <div>
                <DateTimeRangeContainer
                    ranges={ranges}
                    start={this.state.start}
                    end={this.state.end}
                    local={local}
                    maxDate={maxDate}
                    applyCallback={this.applyCallback}
                >
                    <FormControl
                        id="formControlsTextB"
                        type="text"
                        label="Text"
                        // value={moment(this.state.val[0]).format('MMM Do YYYY')+ " - " +moment(this.state.val[1]).format('MMM Do YYYY')}
                         value={moment(this.state.start).tz('Europe/London').format('MMM Do YYYY')+ " - " +moment(this.state.end).tz('Europe/London').format('MMM Do YYYY')}
                        onChange={this.onChange}
                    />
                </DateTimeRangeContainer>
            </div>
        );
    }
}
export default Datepicker;