import React, {Component,Fragment} from 'react';
import Sidenav from "./sidenav";
import Content  from "./content";
import logo from "./images/logo.png";
import Studio from "./studio";
import Android from "./android";
import  Detail from "./detail";
import Appfailed from "./appfailed";
class Main extends Component {
    logout=()=> {
        localStorage.removeItem('email');
        localStorage.removeItem('token');
     window.location.href="/";
    }
    render() {
        return (
            <Fragment>
                <div className="d-flex">
                <section id="sidenav" className="flex-column"  aria-orientation="vertical">
<Sidenav screen={this.props.screen}/>
                </section>
                <section id="main-content">
                    <nav>
                        <div className="user ml-auto">
                            <img src={logo} />
                            <button className="dropdown-toggle" type="button" data-toggle="dropdown">User
                                <span className="caret"></span></button>
                            <ul className="dropdown-menu">
                                <li><a onClick={this.logout}>Logout</a></li>
                            </ul>
                        </div>
                    </nav>

                    {this.props.screen === "ios" && <Content  />}
                    {this.props.screen === "android" && <Android  />}
      {this.props.screen === "failed" && <Appfailed  />}
                    {this.props.screen === "studio" && <Studio />}
                    {this.props.screen === "detail" && <Detail />}
                </section>
                </div>
            </Fragment>
        );
    }
}

export default Main;