import React, { Component } from 'react'
import { Table, Button } from 'reactstrap';
import ModalForm from '../Modals/Modal';
import axios from 'axios';
import { MDBDataTable } from 'mdbreact';
import swal from "sweetalert";
class DataTable extends Component {
    deleteItem = id => {
        const params = {
            id: id
        };
        swal({
            title: "Are you sure?",
            text: "Are you sure that you want to delete thie studio?",
            icon: "warning",
            dangerMode: true,
        })
            .then(willDelete => {
                if (willDelete) {
                    try {
                        const params = {
                            id: id
                        };
                        axios.delete(`https://t2qaedohf6.execute-api.us-east-1.amazonaws.com/stud/studiobo/${id}`, params)
                            // .then(response => response.json())
                            .then(res => {
                                if (res.status == '204') {
                                    console.log("res", res.status);
                                    window.location.reload();
                                } else {
                                    console.log('failure')
                                }
                            })
                    }
                    catch (err) {
                        console.log(err);
                    }
                    swal("Deleted!", "deleted!", "success");
                }
            });
    }

  render() {
   const maxlimit = 50;
    const items = this.props.items.map(item => {
      return (
          {
              Email: (item.email).length > maxlimit ?
             (((item.email).substring(0,maxlimit-3)) + '...') :
               item.email ,
              ID:item.id,
              PrivateKey:(item.privateKey).length > maxlimit ?
                      (((item.privateKey).substring(0,maxlimit-3)) + '...') :
                      item.privateKey ,
              Actions:<div style={{width:"100%"}}>
                        <ModalForm buttonLabel="Edit" item={item} updateState={this.props.updateState}/>
                      {' '}
                        <Button color="danger" onClick={() => this.deleteItem(item.id)}>Del</Button>
                     </div>

          }
        // <tr key={item.id}>
        //
        //   <th scope="row">{ ((item.email).length > maxlimit) ?
        //     (((item.email).substring(0,maxlimit-3)) + '...') :
        //     item.email }</th>
        //   <td>{item.id}</td>
        //   <th scope="row">{ ((item.privateKey).length > maxlimit) ?
        //     (((item.privateKey).substring(0,maxlimit-3)) + '...') :
        //     item.privateKey }</th>
        //   <td>
        //     <div style={{width:"100%"}}>
        //       <ModalForm buttonLabel="Edit" item={item} updateState={this.props.updateState}/>
        //       {' '}
        //       <Button color="danger" onClick={() => this.deleteItem(item.id)}>Del</Button>
        //     </div>
        //   </td>
        // </tr>
        )
      })
      const data = {
          columns: [
              {
                  label: 'Email',
                  field: 'Email',
                  sort: 'asc',
                  width: 150
              },
              {
                  label: 'Studio Name',
                  field: 'ID',
                  sort: 'asc',
                  width: 270
              },
              {
                  label: 'PrivateKey',
                  field: 'PrivateKey',
                  sort: 'asc',
                  width: 200
              },
              {
                  label: 'Actions',
                  field: 'Actions',
                  sort: 'asc',
                  width: 100
              }
          ],
          rows: items

      };
    return (
        <MDBDataTable
            striped
            hover
            data={data}
        />
      // <Table responsive hover className="studiotbl">
      //   <thead>
      //     <tr>
      //       <th>Email</th>
      //       <th>ID</th>
      //       <th >PrivateKey</th>
      //       <th>Actions</th>
      //     </tr>
      //   </thead>
      //   <tbody>
      //     {items}
      //   </tbody>
      // </Table>
    )
  }
}

export default DataTable