import React , {Component,Fragment}from 'react';
import DateTimeRangeContainer from 'react-advanced-datetimerange-picker';
import {FormControl} from 'react-bootstrap';
import moment from "moment"
class Datepicker extends Component {

    constructor(props){
        super(props);
           let now = new Date();
        let start = moment(new Date(now.getFullYear(), now.getMonth(), now.getDate()));
        let end = moment(start).add(1, "days").subtract(1);
       let valstart=moment(start).subtract(14, "days");
        this.state = {
            start : valstart,
            end : end

        }

        this.applyCallback = this.applyCallback.bind(this);
    }

    applyCallback(startDate, endDate){
        this.setState({
                start: startDate,
                end : endDate
            });
        this.props.onChange(startDate,endDate);
    }
    onChange = e => {
     console.log("e")
    }
    render(){
        let now = new Date();
        let start = moment(new Date(now.getFullYear(), now.getMonth(), now.getDate()));
        let end = moment(start).add(1, "days").subtract(1);
        let ranges = {
            "Today Only": [moment(start), moment(end)],
            "Yesterday Only": [moment(start).subtract(1, "days"), moment(end).subtract(1, "days")],
            "Last 1 week": [moment(start).subtract(7, "days"), moment(end)],
            "Last 2 week": [moment(start).subtract(14, "days"), moment(end)],
            "Last 30 Days": [moment(start).subtract(30, "days"), moment(end)]
        }
        let local = {
            "format":"DD-MM-YYYY",
            "sundayFirst" : false
        }
        let maxDate = moment(start).add(24, "hour")
        return(
            <div>
                <DateTimeRangeContainer
                    ranges={ranges}
                    start={this.state.start}
                    end={this.state.end}
                    local={local}
                    maxDate={maxDate}
                    applyCallback={this.applyCallback}
                >
                    <FormControl
                        id="formControlsTextB"
                        type="text"
                        label="Text"
                         value={moment(this.state.start).format('MMM Do YYYY')+ " - " +moment(this.state.end).format('MMM Do YYYY')}
                        onChange={this.onChange}
                    />
                </DateTimeRangeContainer>
            </div>
        );
    }
}
export default Datepicker;